resetMaxFile #noprompt 
sleep 2 

try (destroyDialog ghoCityToolR) catch()
(
	rollout ghoCityToolR "Ghost City Generator" 
	(
		
		group "Building Heights"
		(
			spinner builHeightSP "Average Storeys:" range:[0, 80, 1]\
			type: #integer
			
			spinner builVariesSP "Variation:" range:[0, 40, 1]\
			type: #integer
		)
			
		group "Building Widths"
		(
			spinner builWidthSP "Average Width:" range:[0, 30, 8]\
			type: #integer
		)
	
		group "Number of Buildings"
		(
			radiobuttons densityRB labels: #( "A Few", "A Lot", "Manhattan")\
			align: #center
		)
		
		group "Spread of Buildings"
		(			
			radiobuttons spreadRB labels: #( "Compact", "Cozy", "Comfy")\
			align: #center
		)
		
		group "Generate Buildings"
		(
			button doitBT "Create" 
			button resetBT "Reset" 
		)
		
		group "Randomize All"
		(
			button goBT "Surprise Me"
		)
		
		local buildingsAR = #() 
		
		fn userCreated =
		(
			disableSceneRedraw() 
			for i = 1 to 800 do
			(
				r = random -800 800
				x = random 1 40
				s = builHeightSP.value-builVariesSP.value * random 1 10
				b = box width:builWidthSP.value length:builWidthSP.value height:s
				xPos = builWidthSP.value * 10.0 + 4.0 - 6.0 * x
				b.pos = [xPos, r, 0]
				lastPos = [xPos, 0, 0]
				append buildingsAR b
			)
			
			for j = 1 to 800 do
			(
				r = random -800 800
				x = random 1 40
				s = builHeightSP.value-builVariesSP.value * random 1 10
				b = box width:builWidthSP.value length:builWidthSP.value height:s
				xPos = builWidthSP.value * 2.0 + 4.0 - 6.0 * x
				b.pos = [xPos, r, 0]
				lastPos = [xPos, 0, 0]
				append buildingsAR b 
			)
			
			enableSceneRedraw()
			completeRedraw()
		)
		
		fn randomFun =
		(
			num = random 1 900
				disableSceneRedraw()
				for i = 1 to num do
				(
					r = random -900 800
					x = random 1 40
					h = random 1 90
					wi = random 5 25
					s = h - x * random 1 10
					b = box width:wi length:wi height:s
					oPos = wi * 2.0 + 4.0 - 6.0 * x
					b.pos = [oPos, r, 0]
					lastPos = [oPos, 0, 0]
					append buildingsAR b
				)
				enableSceneRedraw()
				completeRedraw()
		)
		
		on doitBT pressed do
		(
			userCreated()
		)
		
		
			on goBT pressed do
			(
				randomFun()
			)
			
			
		on resetBT pressed do
		(
			selection = buildingsAR 
			(
				delete selection 
				buildingsAR = #()  
			)
			
		)
	)
	createDialog ghoCityToolR pos: [10, 100] width: 190 
)	